/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.projects.model.tables.pojos


import cc.cinnamon.canary.projects.model.tables.interfaces.IProject

import javax.annotation.Generated
import javax.validation.constraints.NotNull
import javax.validation.constraints.Size
import java.sql.Date


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:57:05.285Z", comments = "This class is generated by jOOQ")
class Project : IProject {

    override var id: Long? = null
    @get:NotNull
    @get:Size(max = 200)
    override var name: String? = null
    override var description: String? = null
    @get:Size(max = 120)
    override var homepage: String? = null
    override var created: Date? = null
    @get:Size(max = 200)
    override var shortdesc: String? = null
    @get:Size(max = 60)
    override var category: String? = null
    @get:Size(max = 20)
    override var language: String? = null
    override var licenseId: Long? = null

    constructor() {}

    constructor(value: Project) {
        this.id = value.id
        this.name = value.name
        this.description = value.description
        this.homepage = value.homepage
        this.created = value.created
        this.shortdesc = value.shortdesc
        this.category = value.category
        this.language = value.language
        this.licenseId = value.licenseId
    }

    constructor(
            id: Long?,
            name: String,
            description: String,
            homepage: String,
            created: Date,
            shortdesc: String,
            category: String,
            language: String,
            licenseId: Long?
    ) {
        this.id = id
        this.name = name
        this.description = description
        this.homepage = homepage
        this.created = created
        this.shortdesc = shortdesc
        this.category = category
        this.language = language
        this.licenseId = licenseId
    }

    override fun equals(obj: Any?): Boolean {
        if (this === obj)
            return true
        if (obj == null)
            return false
        if (javaClass != obj.javaClass)
            return false
        val other = obj as Project?
        if (id == null) {
            if (other!!.id != null)
                return false
        } else if (id != other!!.id)
            return false
        if (name == null) {
            if (other.name != null)
                return false
        } else if (name != other.name)
            return false
        if (description == null) {
            if (other.description != null)
                return false
        } else if (description != other.description)
            return false
        if (homepage == null) {
            if (other.homepage != null)
                return false
        } else if (homepage != other.homepage)
            return false
        if (created == null) {
            if (other.created != null)
                return false
        } else if (created != other.created)
            return false
        if (shortdesc == null) {
            if (other.shortdesc != null)
                return false
        } else if (shortdesc != other.shortdesc)
            return false
        if (category == null) {
            if (other.category != null)
                return false
        } else if (category != other.category)
            return false
        if (language == null) {
            if (other.language != null)
                return false
        } else if (language != other.language)
            return false
        if (licenseId == null) {
            if (other.licenseId != null)
                return false
        } else if (licenseId != other.licenseId)
            return false
        return true
    }

    override fun hashCode(): Int {
        val prime = 31
        var result = 1
        result = prime * result + if (id == null) 0 else id!!.hashCode()
        result = prime * result + if (name == null) 0 else name!!.hashCode()
        result = prime * result + if (description == null) 0 else description!!.hashCode()
        result = prime * result + if (homepage == null) 0 else homepage!!.hashCode()
        result = prime * result + if (created == null) 0 else created!!.hashCode()
        result = prime * result + if (shortdesc == null) 0 else shortdesc!!.hashCode()
        result = prime * result + if (category == null) 0 else category!!.hashCode()
        result = prime * result + if (language == null) 0 else language!!.hashCode()
        result = prime * result + if (licenseId == null) 0 else licenseId!!.hashCode()
        return result
    }

    override fun toString(): String {
        val sb = StringBuilder("Project (")

        sb.append(id)
        sb.append(", ").append(name)
        sb.append(", ").append(description)
        sb.append(", ").append(homepage)
        sb.append(", ").append(created)
        sb.append(", ").append(shortdesc)
        sb.append(", ").append(category)
        sb.append(", ").append(language)
        sb.append(", ").append(licenseId)

        sb.append(")")
        return sb.toString()
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    override fun from(from: IProject) {
        id = from.id
        name = from.name
        description = from.description
        homepage = from.homepage
        created = from.created
        shortdesc = from.shortdesc
        category = from.category
        language = from.language
        licenseId = from.licenseId
    }

    /**
     * {@inheritDoc}
     */
    override fun <E : IProject> into(into: E): E {
        into.from(this)
        return into
    }

    companion object {

        private val serialVersionUID: Long = 1457485355
    }
}
